//+------------------------------------------------------------------+
//|                                         RSI_Extremums_Sample.mq4 |
//|                                       Copyright  2009, TheXpert |
//|                                           theforexpert@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, TheXpert"
#property link      "theforexpert@gmail.com"

#property indicator_separate_window

#property indicator_buffers 3
#property indicator_minimum -10
#property indicator_maximum 110
#property indicator_color1  Yellow
#property indicator_color2  Red
#property indicator_color3  Blue
#property indicator_width2  3
#property indicator_width3  3

extern int FastMA=12;
extern int SlowMA=24;
extern int Crosses=50;

// buffers
double Values[];           // values
double Extremums_r[];        // extremums
double Extremums_b[];     

int EmptyValueUsed = 0;

int init()
{
   SetIndexBuffer(0, Values);
   SetIndexBuffer(1, Extremums_r); SetIndexStyle(1, DRAW_ARROW); SetIndexArrow(1, 159);
   SetIndexBuffer(2, Extremums_b); SetIndexStyle(2, DRAW_ARROW); SetIndexArrow(2, 159);
   return(0);
}

int start()
{
   int i,counted_bars=IndicatorCounted();
      if (counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   for (i = limit; i>=0; i--) Values[i] = iCustom(Symbol(),0,"Cycle_KROUFR_version",FastMA,SlowMA,Crosses ,0, i);
   for (i = limit; i>=0; i--) 
   {
      Extremums_r[i] = EMPTY_VALUE;
      Extremums_b[i] = EMPTY_VALUE;
      if (i>0)
      {  
         if (Values[i]>Values[i+1] && Values[i]>Values[i-1]) Extremums_b[i] = Values[i];
         if (Values[i]<Values[i+1] && Values[i]<Values[i-1]) Extremums_r[i] = Values[i];
      }         
   }
   return(0);
}